tigase.xmpp.impl

## Class MobileV3

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.impl.MobileV3

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, XMPPImplIfc, XMPPPacketFilterIfc, XMPPProcessorIfc

      public class MobileV3
      extends AnnotatedXMPPProcessor
      implements XMPPProcessorIfc, XMPPPacketFilterIfc

  Class responsible for queuing packets (usable in connections from mobile clients - power usage optimization) version 3
  Author:
    andrzej

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `ID`
    `protected static String` | `MOBILE_EL_NAME`
    `protected static String` | `XMLNS`

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MobileV3()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `filter(Packet _packet, XMPPResourceConnection sessionFromSM, NonAuthUserRepository repo, Queue<Packet> results)`
    `void` | `init(Map<String,Object> settings)` Method `init` is called just after the plugin has been loaded into memory.
    `protected static boolean` | `isQueueEnabled(XMPPResourceConnection session)` Check if queuing is enabled
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
    `tigase.xml.Element[]` | `supStreamFeatures(XMPPResourceConnection session)` Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `id, supDiscoFeatures, supElementNamePaths, supNamespaces, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, isSupporting, supElements, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, id, isSupporting, supDiscoFeatures, supElementNamePaths, supElements, supNamespaces, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Field Detail

    - #### ID

          protected static final String ID

      See Also:
        Constant Field Values

    - #### MOBILE_EL_NAME

          protected static final String MOBILE_EL_NAME

      See Also:
        Constant Field Values

    - #### XMLNS

          protected static final String XMLNS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MobileV3

          public MobileV3()

  - ### Method Detail

    - #### init

          public void init(Map<String,Object> settings)
                    throws TigaseDBException

      Description copied from interface: `XMPPImplIfc`
      Method `init` is called just after the plugin has been loaded into memory. The idea behind this is to allow it to initialize or check the database. This might be especially useful for plugins which want to have a database access via non-standard stored procedures or need schema upgrade.
      Specified by:
        `init` in interface `XMPPImplIfc`
      Overrides:
        `init` in class `XMPPProcessor`
      Parameters:
        `settings` - is a Map with initial processor settings from the configuration file.
      Throws:
        `TigaseDBException`

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              Queue<Packet> results,
                              Map<String,Object> settings)

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.

    - #### supStreamFeatures

          public tigase.xml.Element[] supStreamFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
      Specified by:
        `supStreamFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supStreamFeatures` in class `AnnotatedXMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### filter

          public void filter(Packet _packet,
                             XMPPResourceConnection sessionFromSM,
                             NonAuthUserRepository repo,
                             Queue<Packet> results)

      Specified by:
        `filter` in interface `XMPPPacketFilterIfc`

    - #### isQueueEnabled

          protected static boolean isQueueEnabled(XMPPResourceConnection session)

      Check if queuing is enabled
      Parameters:
        `session` -

Copyright © 2016 "Tigase, Inc.". All rights reserved.